unit CryptoUtils;

interface

function AES128_Encrypt(Value, Password, ciphername: string): ansistring;
function AES128_Decrypt(Value, Password, ciphername: string): string;
function Base64_Encode(Value: string): string;
function Base64_Decode(Value: string): string;

implementation

uses
  SysUtils, Windows, IdCoderMIME, IdGlobal, Vcl.Dialogs, strutils, aes_main;



//-------------------------------------------------------------------------------------------------------------------------
//    Base64 Encode/Decode
//-------------------------------------------------------------------------------------------------------------------------

function Base64_Encode(Value: string): string;
var
  Encoder: TIdEncoderMIME;
begin
  Encoder := TIdEncoderMIME.Create(nil);
  try
    Result := Encoder.EncodeString(Value);//.EncodeBytes(TIdBytes(Value));
  finally
    Encoder.Free;
  end;
end;

function Base64_Decode(Value: string): string;
var
  Encoder: TIdDecoderMIME;
begin
  Encoder := TIdDecoderMIME.Create(nil);
  try
    Result := Encoder.DecodeString(Value);//.DecodeBytes(Value));
  finally
    Encoder.Free;
  end;
end;

//-------------------------------------------------------------------------------------------------------------------------
//    WinCrypt.h
//-------------------------------------------------------------------------------------------------------------------------

type
  HCRYPTPROV  = Cardinal;
  HCRYPTKEY   = Cardinal;
  ALG_ID      = Cardinal;
  HCRYPTHASH  = Cardinal;
  gcry_cipher_hd_t = pinteger;



const
  _lib_gcrypt    = 'libgcrypt.dll';

//   fgcry_cipher_close = (tgcry_cipher_close)GetProcAddress( m_ModuleHandle, "gcry_cipher_close" );
//
//   fgcry_cipher_encrypt = (tgcry_cipher_encrypt)GetProcAddress( m_ModuleHandle, "gcry_cipher_encrypt" );
//
//   fgcry_cipher_decrypt = (tgcry_cipher_decrypt)GetProcAddress( m_ModuleHandle, "gcry_cipher_decrypt" );
//
//   fgcry_cipher_ctl = (tgcry_cipher_ctl)GetProcAddress( m_ModuleHandle, "gcry_cipher_ctl" );
//
//   fgcry_check_version = (tgcry_check_version)GetProcAddress( m_ModuleHandle, "gcry_check_version" );
//
//   fgcry_randomize = (tgcry_randomize)GetProcAddress( m_ModuleHandle, "gcry_randomize" );
//
//   fgcry_strerror = (tgcry_strerror)GetProcAddress( m_ModuleHandle, "gcry_strerror" );
//
//   fgcry_cipher_open = (tgcry_cipher_open)GetProcAddress( m_ModuleHandle, "gcry_cipher_open" );

       //gcry_cipher_hd_t *hd, int algo, int mode, unsigned int flags
       //gcry_cipher_hd_t h, unsigned char *out, size_t outsize, const unsigned char *in, size_t inlen
       //(gcry_cipher_hd_t h, unsigned char *out, size_t outsize, const unsigned char *in, size_t inlen)
       //(gcry_cipher_hd_t h, int cmd, void *buffer, size_t buflen)
       //fgcry_cipher_setkey( hd, lkey, keylength );
       //fgcry_cipher_close( hd );

function fgcry_cipher_encrypt(var hd:integer ; out :Pchar; outsize  : integer  ; plain    : Pchar; insize: integer):integer; stdcall ; external _lib_gcrypt name 'gcry_cipher_encrypt';
function fgcry_cipher_decrypt(var hd:integer ; out :Pchar; outsize  : integer  ; encoded  : Pchar; insize: integer):integer; stdcall ; external _lib_gcrypt name 'gcry_cipher_decrypt';
function fgcry_cipher_open(   var hd:Pinteger; algo:integer  ; mode     : integer  ; flags    : integer):integer; stdcall ; external _lib_gcrypt name 'gcry_cipher_open';
function fgcry_cipher_ctl(    var hd:integer ; cmd :Integer  ; Buffer   : Pchar; Buffsize : integer):integer; stdcall ; external _lib_gcrypt name 'gcry_cipher_ctl';
function fgcry_randomize(     var hd:integer ; cmd :Integer  ; Buffer   : Pchar; Buffsize : integer):integer; stdcall ; external _lib_gcrypt name 'gcry_randomize';
function fgcry_cipher_setkey( var hd:integer ; lkey:Pchar; Keylength: integer):integer; stdcall ; external _lib_gcrypt name 'gcry_cipher_setkey';
function fgcry_cipher_setiv(  var hd:integer ; IV  :Pchar; Ivlength : integer):integer; stdcall ; external _lib_gcrypt name 'gcry_cipher_setiv';
function fgcry_cipher_close(  var hd:integer ):integer; stdcall ; external _lib_gcrypt name 'gcry_cipher_close';

//-------------------------------------------------------------------------------------------------------------------------

{$WARN SYMBOL_PLATFORM OFF}

//function fgcry_cipher_setkey(hd:gcry_cipher_hd_t; lkey:pwidechar; keylength:integer ):boolean;
//var
//  GCRYCTL_SET_KEY :integer;  //GCRYCTL_SET_KEY: gcry_ctl_cmds=1;
//begin
//   GCRYCTL_SET_KEY:= 1;
//   fgcry_cipher_ctl(hd, GCRYCTL_SET_KEY, lkey, keylength);
//   result:=true;
//end;
//
//function fgcry_cipher_setIv(hd:gcry_cipher_hd_t; IV:pwidechar; keylength:integer ):boolean;
//const
//  GCRYCTL_SET_IV= 2;  //GCRYCTL_SET_IV: gcry_ctl_cmds
//begin
//  // result:=fgcry_cipher_ctl(hd, GCRYCTL_SET_IV, IV, keylength);
//end;
//



function AES128_encrypt(Value, Password, ciphername: string): ansistring;
const
  GCRY_CIPHER_DES      = 302;
  GCRY_CIPHER_AES      = 7;
  GCRYCTL_SET_KEY      = 1;
  GCRYCTL_SET_IV       = 2;
  GCRY_CIPHER_MODE_ECB = 1;

var
  aeskey: Pchar;
  lkey  : Pchar;
  Piv   : Pchar;
  plain : Pchar;
  outbuf: Pchar;
  Hd    : Pinteger;
  des_key :string;
  aes_key :string;
  iv      :string;
  prot    :string;
  pass    :string;
  outt     :string;
  cipher  :integer;
  keylength:integer;
  plainlen :Integer;
  outlen   :integer;
  don      :Integer;
  head,x     :Integer;



begin
  prot:=ciphername;
  pass:=password;
  plainlen  :=length(Value);
  outlen    :=length(value)*2;
  plain     :=Pchar(value);//Pchar(value);
  lkey      :=Pchar(password);
  keylength := 16;
  for x:=0 to outlen do outt:=outt+#00;
  outbuf    :=Pchar(outt);

  setlength(des_key ,9);
//  FillChar( des_key, 9, 0);
  setlength(aes_key ,17);
//  FillChar( aes_key, 17, 0);
  setlength(iv ,33);
//  FillChar( Iv, 33, 0);
  Piv:=Pchar(iv);
//  cipher:=GCRY_CIPHER_AES;

  if prot='AES' then begin
     cipher:=GCRY_CIPHER_AES;
     keylength := 16;
     lkey:=Pchar(aes_key);
     pass:=leftstr(pass,16);
     lkey:=Pchar(pass);
  end else  if prot='DES' then begin
     cipher:=GCRY_CIPHER_DES;
     keylength := 9;
   //  lkey:=PAnsiString(des_key);
     pass:=leftstr(pass,9);
    // lkey:=PAnsiString(pass);
  end else begin
     cipher:=GCRY_CIPHER_AES;
     keylength := 16;
   //  lkey:=PAnsiString(aes_key);
     password:=leftstr(pass,16);
   //  lkey:=PAnsiString(pass);
  end;


 try
  don := fgcry_cipher_open( hd, cipher, GCRY_CIPHER_MODE_ECB, 0 );
  if don<> 0 then showmessage('Failed opening AES cipher: '+don.ToString);

  head:=integer(hd);

  don := fgcry_cipher_ctl(hd^, GCRYCTL_SET_KEY, lkey, keylength);
  //don := fgcry_cipher_setkey( head, lkey, keylength );
  if don<> 0 then  showmessage('Failed setkey: '+don.ToString);

  form1.memo2.Lines.Add((don+1).ToString);

  //don := fgcry_cipher_ctl(hd^, GCRYCTL_SET_IV, Piv, keylength);
  //don := fgcry_cipher_setiv( hd, Piyv, keylength );

  if don<> 0 then showmessage('Failed setiv: ');

 // form1.memo2.Lines.Add((don+2).ToString);

   form1.Memo3.Lines.Add('plain '+string(plain)+' plainlen '+plainlen.ToString+' out '+string(outbuf)+' outlen '+outlen.ToString+' lkey '+string(lkey)+' IV '+string(pIV) );
   //setlength(outbuf, outlen);

  don := fgcry_cipher_encrypt(hd^, outbuf, outlen, plain, plainlen);
  if don> 1 then showmessage('Failed encrypt: '+don.ToString);

  form1.memo2.Lines.Add((don+3).ToString);

  don:=fgcry_cipher_close( hd^ );
  if don> 1 then showmessage('Failed Close session: '+don.ToString);

  form1.memo2.Lines.Add((don+4).ToString);

  result:=ansistring(outbuf);

  form1.memo3.Lines.Add(string(result));
 except on e:exception do begin
    form1.Memo3.Lines.Add('Hata classname: '+e.ClassName+' message '+e.Message);
    e.CleanupInstance;
   // a:=plain^;
   // b:=outbuf^;
   // form1.Memo3.Lines.Add('plain '+a+' plainlen '+plainlen.ToString+' out '+b+' outlen '+outlen.ToString);
  end;

 end;
end;




function AES128_Decrypt(Value, Password, ciphername: string): string;
const
  GCRY_CIPHER_DES      = 302;
  GCRY_CIPHER_AES      = 7;
  GCRYCTL_SET_KEY      = 1;
  GCRYCTL_SET_IV       = 2;
  GCRY_CIPHER_MODE_ECB = 1;

var
  aeskey: PString;
  lkey  : PString;
  Piv   : PString;
  crypted:PString;
  outbuf: PString;
  Hd    : Pinteger;
  des_key :string;
  aes_key :string;
  iv      :string;
  prot    :string;
  cipher  :integer;
  keylength :integer;
  cryptedlen: Integer;
  head      : Integer;
  outlen    : integer;
  err       : integer;

begin
  setlength(des_key ,9);
  FillChar( des_key, 9, $00);
  setlength(aes_key ,17);
  FillChar( aes_key, 17, $00);
  setlength(iv ,33);
  FillChar( iv, 33, $00);
  Piv:=PString(iv);

  cryptedlen:=length(Value);
  outlen    :=length(value)*2;
  crypted   :=PString(value);
  outbuf    :=PString(value+value);

  keylength := 16;

  if prot='AES' then begin
     cipher:=GCRY_CIPHER_AES;
     keylength := 16;
     lkey:=PString(aes_key);
     password:=leftstr(password,16);
     lkey:=PString(password);
  end else  if prot='DES' then begin
     cipher:=GCRY_CIPHER_DES;
     keylength := 9;
     lkey:=PString(des_key);
     password:=leftstr(password,9);
     lkey:=PString(password);
  end else begin
     cipher:=GCRY_CIPHER_AES;
     keylength := 16;
     lkey:=PString(aes_key);
     password:=leftstr(password,16);
     lkey:=PString(password);
  end;


  err := fgcry_cipher_open( hd, cipher, GCRY_CIPHER_MODE_ECB, 0 );
  if err <> 0 then showmessage('Failed opening AES cipher: '+err.ToString);
  head:=integer(hd);

 // err := fgcry_cipher_ctl(hd^, GCRYCTL_SET_KEY, lkey, keylength);
  if err <> 0 then showmessage('Failed setkey: '+err.ToString);

 // err := fgcry_cipher_ctl(hd^, GCRYCTL_SET_IV, Piv, keylength);
  if err <> 0 then showmessage('Failed setiv: '+err.ToString);


 // err := fgcry_cipher_decrypt( hd^, outbuf, cryptedlen, crypted, cryptedlen);
  if err <> 0 then showmessage('Failed encrypt: '+err.ToString);

  err :=fgcry_cipher_close(hd^);
  if err <> 0 then showmessage('Failed Close: '+err.ToString);

  result:=ansistring(outbuf);

end;


end.
